# GetValueOrDefault\<T>(IGeneratedVariableStorage,string)

Method in [GeneratedVariableStorageExtensions](/api/csharp/yarn.unity/yarn.unity.generatedvariablestorageextensions.md)

## Summary

Gets a value for the variable `variableName` from `storage` , or else returns the default value of `T` .

```csharp
public static T? GetValueOrDefault<T>(this IGeneratedVariableStorage storage, string variableName)
    where T : IConvertible
```

## Parameters

| Name                                                                                                           | Description                                                 |
| -------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------- |
| [Yarn.Unity.IGeneratedVariableStorage](/api/csharp/yarn.unity/yarn.unity.igeneratedvariablestorage.md) storage | The generated variable storage class to get the value from. |
| `string` variableName                                                                                          | The name of the variable to get a value for.                |

## Type Parameters

| Name | Description                                   |
| ---- | --------------------------------------------- |
| T    | The type of the parameter to get a value for. |

## Returns

The value of `variableName` , or the default value of `T` .


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/api/csharp/yarn.unity/yarn.unity.generatedvariablestorageextensions/yarn.unity.generatedvariablestorageextensions.getvalueordefault.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
